//+------------------------------------------------------------------+
//|                                                  Equity_pips.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               12.12.2009 |
//|                                 http://codebase.mql4.com/ru/4455 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"

#property indicator_separate_window
#property indicator_buffers 2

extern string Only_Magics="";    //       (  )
extern string Only_Comment="";   //       ( [sl]  [tp])
extern bool   Only_Buys=false;   //     
extern bool   Only_Sells=false;  //     
extern bool   Show_Balance=true; //  

double   Equity[],Balance[];

datetime OpenTime_Ticket[][2];   //     
int      OpenBar[];              //   
int      CloseBar[];             //   
int      Type[];                 //  
double   OpenPrice[];            //  
double   ClosePrice[];           //  

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
 string ShortName=Symbol();
 if (Only_Magics!="")  ShortName=StringConcatenate(ShortName," ",Only_Magics);
 if (Only_Comment!="") ShortName=StringConcatenate(ShortName," ",Only_Comment);
 if (Only_Sells)
 {
  Only_Buys=false;
  ShortName=StringConcatenate(ShortName," Sells");
 }
 else if (Only_Buys)  ShortName=StringConcatenate(ShortName," Buys");
 SetIndexBuffer(0,Equity);
 SetIndexLabel(0,"Equity");
 SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,SteelBlue);
 SetIndexBuffer(1,Balance);
 SetIndexLabel(1,"Balance");
 SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2,OrangeRed);
                   ShortName=StringConcatenate(ShortName," Equity");
 if (Show_Balance) ShortName=StringConcatenate(ShortName," Balance");
 IndicatorShortName(ShortName);
 IndicatorDigits(0);
 return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
 static int anumber=-1;
 static bool first;
 static double currentbalance;
 double profitloss;
 int spread,i,j,start,total,historytotal,opentotal;

 if (anumber!=AccountNumber())
 {
  ArrayInitialize(Balance,EMPTY_VALUE);
  ArrayInitialize(Equity,EMPTY_VALUE);
  anumber=AccountNumber();
  first=true;
 }
 if (!OrderSelect(0,SELECT_BY_POS,MODE_HISTORY)) return(0);
 if (first)
 {
  first=false;
  historytotal=OrdersHistoryTotal();
  opentotal=OrdersTotal();
  total=historytotal+opentotal;
  ArrayResize(OpenTime_Ticket,total);
  for (i=0;i<historytotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
  {
   if (Select())
   {
    OpenTime_Ticket[i][0]=OrderOpenTime();
    OpenTime_Ticket[i][1]=OrderTicket();
   }
   else
   {
    OpenTime_Ticket[i][0]=EMPTY_VALUE;
    total--;
   }
  }
  if (opentotal>0)
  {
   for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   {
    if (Select())
    {
     OpenTime_Ticket[historytotal+i][0]=OrderOpenTime();
     OpenTime_Ticket[historytotal+i][1]=OrderTicket();
    }
    else
    {
     OpenTime_Ticket[historytotal+i][0]=EMPTY_VALUE;
     total--;
    }
   }
  }
  ArraySort(OpenTime_Ticket);
  ArrayResize(OpenTime_Ticket,total);
  ArrayResize(OpenBar,total);
  ArrayResize(CloseBar,total);
  ArrayResize(Type,total);
  ArrayResize(OpenPrice,total);
  ArrayResize(ClosePrice,total);
  for (i=0;i<total;i++) if (OrderSelect(OpenTime_Ticket[i][1],SELECT_BY_TICKET))
  {
   OpenBar[i]=iBarShift(NULL,0,OrderOpenTime());
   Type[i]=OrderType();
   OpenPrice[i]=OrderOpenPrice();
   if (OrderCloseTime()!=0)
   {
    CloseBar[i]=iBarShift(NULL,0,OrderCloseTime());
    ClosePrice[i]=OrderClosePrice();
   }
   else
   {
    CloseBar[i]=0;
    ClosePrice[i]=0;
   }
  }
  start=0;
  currentbalance=0;
  for (i=OpenBar[0];i>=0;i--)
  {
   profitloss=0;
   for (j=start;j<total;j++)
   {
    if (OpenBar[j]<i) break;
    if (CloseBar[start]>i) start++;
    if (CloseBar[j]==i && ClosePrice[j]!=0)
    {
     if (Type[j]==OP_BUY) currentbalance+=ClosePrice[j]-OpenPrice[j];
     else currentbalance+=OpenPrice[j]-ClosePrice[j];
    }
    else if (OpenBar[j]>=i && CloseBar[j]<=i)
    {
     if (Type[j]==OP_BUY) profitloss+=Close[i]-OpenPrice[j];
     else
     {
      spread=MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT);
      profitloss+=OpenPrice[j]-Close[i]-spread;
     }
    }
   }
                     Equity[i]=NormalizeDouble((currentbalance+profitloss)/Point,0);
   if (Show_Balance) Balance[i]=NormalizeDouble(currentbalance/Point,0);
  }
  ArrayResize(OpenTime_Ticket,opentotal);
  if (opentotal>0) for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) OpenTime_Ticket[i][1]=OrderTicket();
 }
 else
 {
  opentotal=ArraySize(OpenTime_Ticket);
  if (opentotal>0)
  {
   for (i=0;i<opentotal;i++)
   {
    if (!OrderSelect(OpenTime_Ticket[i][1],SELECT_BY_TICKET)) continue;
    if (OrderCloseTime()==0) continue;
    else if (Select())
    {
     if (Type[j]==OP_BUY) currentbalance+=ClosePrice[i]-OpenPrice[i];
     else currentbalance+=OpenPrice[i]-ClosePrice[i];
    }
   }
  }
  profitloss=0;
  opentotal=OrdersTotal();
  if (opentotal>0)
  {
   for (i=0;i<opentotal;i++)
   {
    if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
    if (Select())
    {
     if (Type[i]==OP_BUY) profitloss+=Close[i]-OpenPrice[i];
     else
     {
      spread=MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT);
      profitloss+=OpenPrice[i]-Close[i]-spread;
     }
    }
   }
  }
                    Equity[0]=NormalizeDouble((currentbalance+profitloss)/Point,0);
  if (Show_Balance) Balance[0]=NormalizeDouble(currentbalance/Point,0);
  ArrayResize(OpenTime_Ticket,opentotal);
  if (opentotal>0) for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) OpenTime_Ticket[i][1]=OrderTicket();
 }
 SetLevelValue(0,Equity[0]);
 return(0);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool Select()
{
 if (OrderType()>1) return(false);
 if (OrderSymbol()!=Symbol()) return(false);
 if (Only_Magics!="" && StringFind(Only_Magics,DoubleToStr(OrderMagicNumber(),0))==-1) return(false);
 if (Only_Comment!="" && StringFind(OrderComment(),Only_Comment)==-1) return(false);
 if (Only_Buys && OrderType()!=OP_BUY) return(false);
 if (Only_Sells && OrderType()!=OP_SELL) return(false);
 return(true);
}
//+------------------------------------------------------------------+